/*
 * Created on 04.12.2005
 */
package gui;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

import algo.Simplex;

/**
 * @author Sibel Cilek und Daniela Zielke, AI7
 */
public class AnzahlFrame extends JFrame implements ActionListener{

	private JFrame fenster;
	private static JTextField textAnzahlVar;
	private static JTextField textAnzahlBed;
	private static JButton okAnzahl = new JButton("OK");
	// Variablen fr Anzahl der Variablen und Bedingungen
	private static int anzVariablen = 2;
	private static int anzBedingungen = 3;
	
	public AnzahlFrame(){
		super("Simplex-Algorithmus");
		
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		/* Methoden, zum Festlegen der Gre und Position des Fensters */
		this.setPreferredSize(new Dimension(500,80));
		this.setLocation(250,100);
		/* Layout fr die Darstellung des Fensters */
		getContentPane().setLayout(new GridLayout(2,3,2,2));
		fenster = this;
		okAnzahl.addActionListener(this);
		/* Ein eigenes JPanel, auf dem die Daten fr Anzahl Variable und Bedingung
		 * eingegeben werden*/
		getContentPane().add(new JLabel("Anzahl Variablen (max.3)"));
		textAnzahlVar = new JTextField("2",0);
		textAnzahlVar.setPreferredSize(new Dimension(5,20));
			
		getContentPane().add(textAnzahlVar);
		getContentPane().add(new JLabel(""));
		getContentPane().add(new JLabel("Anzahl Bedingungen (max.4)"));
			
		textAnzahlBed = new JTextField("3",0);
		textAnzahlBed.setPreferredSize(new Dimension(5,20));
		getContentPane().add(textAnzahlBed);
		okAnzahl.setPreferredSize(new Dimension(1,20));
		getContentPane().add(okAnzahl);
		pack();
		setVisible(true);
	}
	
	public void actionPerformed (ActionEvent e){
		if(pruefeEingabe()){
			fenster.setVisible(false);	
			SimplexGUI gui = new SimplexGUI(this.anzVariablen,this.anzBedingungen);
		}
	}
	
	public boolean pruefeEingabe(){
		boolean eingabeOK = true;
		// gibt zurck, ob es sich um ein Minimum oder Maximum handelt
		anzVariablen = new Integer(textAnzahlVar.getText()).intValue();
		anzBedingungen = new Integer(textAnzahlBed.getText()).intValue();
		if((anzVariablen > 3) || (anzVariablen <= 0)){                   
			JOptionPane.showMessageDialog(fenster,"Es kann nur eine Anzahl von 1-3 Variablen eingegeben werden.","Fehler",JOptionPane.WARNING_MESSAGE);
			eingabeOK = false;
		}	
		if((anzBedingungen > 4 )|| (anzBedingungen <= 0)){
			JOptionPane.showMessageDialog(fenster,"Es kann nur eine Anzahl von 1-4 Bedingungen eingegeben werden.","Fehler",JOptionPane.WARNING_MESSAGE);
			eingabeOK = false;
		}	
		if(anzBedingungen < anzVariablen){
			JOptionPane.showMessageDialog(fenster,"Die Anzahl der Bedingungen muss grer gleich der Anzahl der Variablen sein.","Fehler",JOptionPane.WARNING_MESSAGE);
			eingabeOK = false;
		}
		return eingabeOK;
	}
	
	/**
	 * @return Returns the anzBedingungen.
	 */
	public int getAnzBedingungen() {
		return this.anzBedingungen;
	}

	/**
	 * @return Returns the anzVariablen.
	 */
	public int getAnzVariablen() {
		return this.anzVariablen;
	}
}
