package gui;

/*
 * Created on 24.11.2005
 * TODO:	Eingabe der Daten bernehmen
 * 			Gleichungen an Eingabe Anzahl anpassen
 * 			Ausgabe der Iterationen 
 * 			Ausgabe Lsung
 * 			3D-Darstellung Simplex
 */
import java.awt.*;
import java.awt.event.*;
import java.util.ArrayList;
import javax.swing.*;
import algo.Simplex;
import algo.SimplexRatio;

/**
 * @author Sibel Cilek und Daniela Zielke, AI7
 */
public class SimplexGUI extends JFrame implements ActionListener{

	// Panel fr Eingabe
	private static JPanel Bed_Eingabe = new JPanel();
	private static Ausgabe Erg_Ausgabe;
	private static JFrame fenster;
	private static JTextField [] x ;
	private static JTextField [] b;
	private static JComboBox MinMax = new JComboBox();
	private static JButton okGleichungen = new JButton("OK");
	// Variablen fr Anzahl der Variablen und Bedingungen
	private static int anzVariablen = 2;
	private static int anzBedingungen = 3;
	private static int getMinMax = 0;
	private static double tableau[][];
	private static ArrayList listTableaus = new ArrayList();
				
	/**
	 * Konstruktor: zeichnet Oberflche
	 */
	public SimplexGUI(int anzVar,int anzBed){
		super("Simplex-Algorithmus");
				
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		/* Methoden, zum Festlegen der Gre und Position des Fensters */
		this.setPreferredSize(new Dimension(580,400));
		setLocation(250,100);
		fenster = this;
		this.anzVariablen = anzVar;
		this.anzBedingungen = anzBed;
		/* Layout fr die Darstellung des Fensters */
		getContentPane().setLayout(new BorderLayout(5,5));
				
		okGleichungen.addActionListener(this);
		x = new JTextField[this.anzVariablen*(this.anzBedingungen+1)];
		b = new JTextField[this.anzBedingungen+1];
		zeichnePanelGleichungen();
		getContentPane().add(Bed_Eingabe,BorderLayout.NORTH);
		getContentPane().add(new JSeparator(),BorderLayout.CENTER);
		pack();
		setVisible(true);
	}
		
	/**
	 * Methode zeichnet die Oberflche fr die Eingabe
	 * der Gleichungen
	 */
	public void zeichnePanelGleichungen(){
		/* Ein eigenes JPanel, auf dem die Bedingungen eingegeben werden*/
		Bed_Eingabe.setLayout(new GridLayout(anzBedingungen+2,0,2,2));
		MinMax.addItem("Maximiere");
		MinMax.addItem("Minimiere");
		MinMax.setPreferredSize(new Dimension(40,10));
		for(int i=0;i<= this.anzBedingungen;i++){
			JPanel zeile = new JPanel(new GridLayout(1,7,2,2));
			// Prfe, ob Zielfunktion oder Bedingung
			if(i == 0)
				zeile.add(MinMax);
			else
				zeile.add(new JLabel("Bedingung " + i));
			for(int j=0;j<this.anzVariablen;j++){
				x[j+(i*this.anzVariablen)] = new JTextField(0);
				zeile.add(x[j+(i*this.anzVariablen)]);
				JLabel x;
				if(j != (this.anzVariablen-1)){
					x = new JLabel("* x" + (j+1) + " +",JLabel.CENTER);
					zeile.add(x);
				}
				else{
					x = new JLabel("* x" + (j+1),JLabel.CENTER);
					zeile.add(x);
					JLabel gleich;
					if(i==0)
						gleich = new JLabel(" = ",JLabel.CENTER);
					else
						gleich = new JLabel(" <= ",JLabel.CENTER);
					zeile.add(gleich);
				}				
			}
			b[i] = new JTextField(0);
			zeile.add(b[i]);
			Bed_Eingabe.add(zeile);
		}
		okGleichungen.setPreferredSize(new Dimension(1,20));
		Bed_Eingabe.add(okGleichungen);
	}
		
	public void actionPerformed (ActionEvent e){
		Simplex algo = new Simplex();
		//SimplexRatio algo = new SimplexRatio();
		algo.setMinMaxProblem(getGetMinMax());
		algo.setAnzSpalten(getAnzVariablen()+1);
		algo.setAnzZeilen(getAnzBedingungen()+1);
		algo.setTableau(getTableau());
		algo.starteRechnung();
		algo.getAnzIterationen();
		this.listTableaus = algo.getListTableaus();
		//algo.ausgabe();
		setAnzBedingungen(algo.getAnzZeilen());
		setAnzVariablen(algo.getAnzSpalten());
		Erg_Ausgabe = new Ausgabe(this.listTableaus);
		Erg_Ausgabe.setPreferredSize(new Dimension(550,600));
		Erg_Ausgabe.setGetMinMax(this.getGetMinMax());
		Erg_Ausgabe.setAnzBedingungen(getAnzBedingungen());
		Erg_Ausgabe.setAnzVariablen(getAnzVariablen());
		Erg_Ausgabe.setE_x(algo.getX());
		Erg_Ausgabe.showTableau();
		JScrollPane ausgabe = new JScrollPane(Erg_Ausgabe);
		ausgabe.setPreferredSize(new Dimension(570,(this.anzBedingungen*30*this.listTableaus.size())));
		ausgabe.setVisible(true);
		fenster.getContentPane().add(ausgabe,BorderLayout.CENTER);
		fenster.pack();
		fenster.setVisible(true);
	}
		
	/**
	 * @return Returns the anzBedingungen.
	 */
	public int getAnzBedingungen() {
		return this.anzBedingungen;
	}

	/**
	 * @return Returns the anzVariablen.
	 */
	public int getAnzVariablen() {
		return this.anzVariablen;
	}
	
	/**
	 * @return Returns the getMinMax.
	 */
	public int getGetMinMax() {
		this.getMinMax = MinMax.getSelectedIndex();
		return this.getMinMax;
	}

	/**
	 * @return Returns the tableau.
	 */
	public double[][] getTableau() {
		this.tableau = new double[this.anzBedingungen+1][this.anzVariablen+1];
		int k=0;
		for(int i=0;i<=this.anzBedingungen;i++){
			for(int j=0;j<=this.anzVariablen;j++){
				if(i==0)
					k = this.anzBedingungen;
				else
					k = i-1;
				if(j == this.anzVariablen)
					this.tableau[k][j] = (new Double(b[i].getText()).doubleValue());
				else
					this.tableau[k][j] = (new Double(x[j+(i*this.anzVariablen)].getText()).doubleValue());
			}
		}
		for(int j=0;j<=this.anzVariablen;j++){
			this.tableau[anzBedingungen][j] = -	this.tableau[anzBedingungen][j];
		}
		return this.tableau;
	}

	/**
	 * @param tableau The tableau to set.
	 */
	public void setTableau(double[][] tableau) {
		this.tableau = tableau;
	}
	
	/**
	 * @param anzBedingungen The anzBedingungen to set.
	 */
	public void setAnzBedingungen(int anzBedingungen) {
		this.anzBedingungen = anzBedingungen;
	}

	/**
	 * @param anzVariablen The anzVariablen to set.
	 */
	public void setAnzVariablen(int anzVariablen) {
		this.anzVariablen = anzVariablen;
	}
}
